new;

declare matrix rho;

fn rndu2(r,c,a,b) = a + (b-a) .* rndu(r,c);

proc pdfn2(x1,x2,mu1,mu2,sigma1,sigma2,rho);
  local w,x12,pdf;

  w = 1 - rho^2;

  x1 = (x1 - mu1)/sigma1;
  x2 = (x2 - mu2)/sigma2;
  pdf = x1^2 - 2 * rho * x1 .* x2 + x2^2;
  pdf = exp(-0.5*pdf/w)/(2*pi*sigma1*sigma2*sqrt(w));
  
  retp(pdf);
endp;

fn pdfn2_cr(x,y,rho) = pdfn2(x,y,0,0,1,1,rho);

fn FnInt(x,y) = pdfn2_cr(x,y,rho);

I = zeros(4,1);
  

/*
** Carre [0,1] x [0,1]
*/
 
rho = 0.5;

_intord = 40;
I[1] = intquad2(&FnInt,1|0,1|0);    @ Methode I : intquad1  @
I[2] = cdfbvn2(0,1,0,1,rho);        @ Methode II : cdfbvn2   @

ns = 5000;
x = rndu(ns,1); y = rndu(ns,1);
aire = 1;
I[3] = aire * meanc(pdfn2(x,y,0,0,1,1,rho));  @ Method III : calcul d'une aire 
                                                             par simulation           @
x = rndn(ns,1);
y = rho * x + sqrt(1-rho^2) * rndn(ns,1);
I[4] = meanc( x .>= 0 .and x .<= 1 
           .and y .>= 0 .and y .<= 1);        @ Method IV : calcul d'une probabilite 
                                                            par simulation            @

print I;
print;

/*
** Carre [-1,1] x [-1,1]
*/
 
rho = 0.5;
I[1] = intquad2(&FnInt,1|-1,1|-1); 
I[2] = cdfbvn2(-1,2,-1,2,rho);

ns = 5000;
x = rndu2(ns,1,-1,1); y = rndu2(ns,1,-1,1);
aire = 4;
I[3] = aire * meanc(pdfn2(x,y,0,0,1,1,rho));

x = rndn(ns,1);
y = rho * x + sqrt(1-rho^2) * rndn(ns,1);
I[4] = meanc( x .>= -1 .and x .<= 1 .and y .>= -1 .and y .<= 1);

print I;


