

proc (1) = LoadData(dataset,vars);
  local name,indx,c,f,r,x,nr,r1,r2,data;

  {name,indx} = indices(dataset,vars);
  c = rows(indx);

  open f = ^dataset for read;

  r = rows(f);
  x = zeros(r,c);
  nr = getnr(6,colsf(f));

  r1 = 1;
  r2 = 0;

  do until eof(f);
    data = readr(f,nr);
    r2 = r1 + rows(data) - 1;
    x[r1:r2,.] = submat(data,0,indx); 
    r1 = r2 + 1;
  endo;

  f = cols(f);

  retp(x);
endp;

proc (0) = CopyData(dataset,vars,newdataset);
  local name,indx,c,fin,fout,nr;

  {name,indx} = indices(dataset,vars);
  c = rows(indx);

  open fin = ^dataset for read;
  create fout = ^newdataset with ^name,c,8;

  nr = getnr(6,colsf(fin));

  do until eof(fin);
    call writer(fout,submat(readr(fin,nr),0,indx));
  endo;

  closeall fin, fout;

  retp;
endp;

proc (1) = LoadDataIf(dataset,vars,procCnd,varsCnd);
  local procCnd:proc;
  local name,indx,indxCnd,c,f,nr,data,x;

  {name,indx} = indices(dataset,vars);
  c = rows(indx);
  {name,indxCnd} = indices(dataset,varsCnd);

  open f = ^dataset for read;

  x = {};
  nr = getnr(6,colsf(f));

  do until eof(f);
    data = readr(f,nr);
    data = selif(data[.,indx],procCnd(data[.,indxCnd]));
    if data /= error(0);
      x = x | data;
    endif;
  endo;

  f = cols(f);

  retp(x);
endp;

proc (1) = LoadRows(dataset,vars,row);
  local name,indx,c,f,r,x,nr,i;

  {name,indx} = indices(dataset,vars);
  c = rows(indx);

  open f = ^dataset for read;

  r = rows(row);
  x = miss(zeros(r,c),0);
  nr = getnr(6,colsf(f));
  row = missex(row, row .> rowsf(f) );

  i = 1; 
  do until i > r;
    if ismiss(row[i]);
      i = i + 1;
      continue;
    endif;
    call seekr(f,row[i]);
    x[i,.] = submat(readr(f,1),0,indx); 
    i = i + 1;
  endo;

  f = cols(f);

  retp(x);
endp;