new;
library ritme,pgraph,optmum;

rndseed 123456;

alpha0 = 0.5;
alpha1 = 0.5;
beta1 = 0.2;

u = zeros(100,1);
h = zeros(100,1);

i = 2;
do until i > 100;
  h[i] = sqrt(alpha0 + alpha1*u[i-1]^2 + beta1*h[i-1]^2);
  u[i] = rndn(1,1)*h[i];
  i=i+1;
endo;

x = seqa(0,0.5,100);
y = 2 + 3*x + u;
data = y~x;

proc negML(theta);
  local nobs,u,h2,i,logl;

  theta[3 4 5] = sqrt(theta[3 4 5]^2);    /* Positivite de la variance */

  nobs = rows(data);
  u = data[.,1] - theta[1] - theta[2]*data[.,2];
  h2 = zeros(nobs,1);
  h2[1] = theta[3];

  i = 2;
  do until i > nobs;
    h2[i] = theta[3] + theta[4]*u[i-1]^2 + theta[5]*h2[i-1];
    i = i + 1;
  endo;

  logl = -0.5*ln(2*pi) - 0.5*ln(h2) - 0.5*u.*u./h2;

  retp( -sumc(logl) );
endp;

beta = y / (ones(100,1)~x);
sv = beta|1|1|1;

{theta,Logl,grd,retcode} = optmum(&negML,sv);
theta[3 4 5] = sqrt(theta[3 4 5]^2);

nobs = rows(data);
u = data[.,1] - theta[1] - theta[2]*data[.,2];
h2 = zeros(nobs,1);
h2[1] = theta[3];

i = 2;
do until i > nobs;
  h2[i] = theta[3] + theta[4]*u[i-1]^2 + theta[5]*h2[i-1];
  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; _plwitdh = 5;
  xtics(0,100,10,10);
  xlabel("\214t");
  ylabel("\214h[2]]t[");
  title("\214Conditional variance");
  graphprt("-c=1 -cf=garch3.ps");
  xy(seqa(1,1,100),h2);




