new;
library ritme,optmum;

cls;

rndseed 123;

n = 250;
alpha0 = 0.5; alpha1 = 0.6;

u = zeros(n,1);
h = zeros(n,1);
i = 2;
do until i > n;
  h[i] = sqrt(alpha0^2 + alpha1^2*u[i-1]^2);
  u[i] = rndn(1,1)*h[i];
  i = i + 1;
endo;

x =  3*rndu(n,1);
y = 2 + 3*x + u;

proc ARCH(theta);
  local M,u,h2,u2;

  M = zeros(n,4);
  u = y - theta[1] - theta[2] * x;

  /* first moment */
  M[.,1] = u;

  /* computing h(t)^2 */
  u2 = u .* u;
  h2 = theta[3]^2 + theta[4]^2 * lag1(u2);
  h2[1] = theta[3]^2;

  /* second moment */
  M[.,2] = u2 - h2;

  /* u(t) uncorrelated with x(t) */
  M[.,3] = x .* u;

  /* u(t)^2-h(t)^2 uncorrelated with u(t-i)^2, i = 1 */
  M[.,4] = (u2-h2).*lagn(u2,1);

  retp(M);
endp;

sv = 2|3|0.5|0.6;
_gmm_tol = 1e-10;
{theta,stderr,cov,Q} = gmm(&arch,sv);

