new;
library ritme,optmum;

cls;

rndseed 123;

n = 1000;
x = 10*rndu(n,4);
z = x^2;

beta = rndn(4,1);
sigma = 2;
y = x*beta + rndn(n,1)*sigma;

sv = beta|sigma; /* starting values */

proc H1(theta);
  local beta,sigma,u,M,i;

  M = zeros(n,6);

  beta = theta[1:4];
  sigma = theta[5];

  /* first moment */
  u = y - x*beta;
  M[.,1] = u;
  /* second moment */
  M[.,2] = u.*u - sigma^2;

  i = 1;
  do until i > 4;
    M[.,2+i] = u.*x[.,i];
    i = i + 1;
  endo;

  retp(M);
endp;

proc H2(theta);
  local beta,sigma,u,M,i;

  M = zeros(n,6);

  beta = theta[1:4];
  sigma = theta[5];

  /* first moment */
  u = y - x*beta;
  M[.,1] = u;
  /* second moment */
  M[.,2] = u.*u - sigma^2;

  i = 1;
  do until i > 4;
    M[.,2+i] = u.*z[.,i];
    i = i + 1;
  endo;

  retp(M);
endp;

_gmm_tol = 1e-7;

{theta1,stderr,cov,Q} = gmm(&h1,sv);

{theta2,stderr,cov,Q} = gmm(&h2,sv);

print theta1~theta2;

print "OLS" invpd(x'x)*x'y;
print "IV" invpd(x'*z*invpd(z'*z)*z'*x)*x'*z*invpd(z'*z)*z'*y;
