new;
library optmum;

n = 100;
let beta = 1 2 3;
sigma = 2;

x = 100*rndu(n,3);
y = x*beta + sigma * rndn(n,1);

b_ols = y/x;
u = y - x*b_ols;
rss = sumc(u^2);
df = rows(x) - cols(x);
df = rows(x);               /* POUR RETROUVER LES RESULTATS ML */
sigma_ols = sqrt(rss/df);

theta_ols = b_ols /* | sigma_ols */ ;

cov_ols = (sigma_ols^2) * invpd(x'x);
stderr_ols = sqrt(diag(cov_ols));
tstudent_ols = theta_ols ./ stderr_ols;
pvalue_ols = 2*cdftc(abs(tstudent_ols),df);

proc logl(theta);
  local b,sigma2,L,u;

  b = theta[1:3];
  sigma2 = theta[4]^2;

  u = y - x*b;
  L = -0.5*ln(2*pi) - 0.5*ln(sigma2) - 0.5*(u.*u)/sigma2;

  retp(L);
endp;

proc fmin(theta);
  retp( -sumc(logl(theta)) );
endp;

let sv = 1 1 1 1 ;
_opgtol = 1e-7;
{theta_ml,f,g,retcode} = optmum(&fmin,sv);

b_ml = theta_ml[1:3];
sigma_ml = theta_ml[4];

H = -hessp(&fmin,theta_ml);
cov_ml = invpd(-H);
stderr_ml = sqrt(diag(cov_ml));
tstudent_ml = theta_ml ./ stderr_ml;
pvalue_ml = 2*cdftc(abs(tstudent_ml),df);

cls;

call printfmt(theta_ols~stderr_ols~tstudent_ols~pvalue_ols,1);
print;
call printfmt(theta_ml~stderr_ml~tstudent_ml~pvalue_ml,1);