/*
**   The data are taken from Douglas M. Bates and Donald G. Watts,
**   Nonlinear Regression Analysis and Its Applications, page 269.
**
*/

new;
library ritme,optmum;

/*  treated  */
y1 = { 76,   47,   97,  107,  123,  139,  159,  152,  191,  201,  207,  200 };
x1 = { .02,  .02,  .06,  .06,  .11,  .11,  .22,  .22,  .56,  .56,  1.1,  1.1 };

/*  untreated  */
y2 = { 67,   51,   84,   86,   98,  115,  131,  124,  144,  158,  160 };
x2 = { .02,  .02,  .06,  .06,  .11,  .11,  .22,  .22,  .56,  .56,  1.1 };

y = y1 | y2;
x = x1 | x2;

proc model(b);
    retp(y - b[1]*x./(b[2] + x));
endp;

let sv = 100 5;

__output = 1;

_nlls_cov = 1;

output file = nlls1.out reset;

{beta,stderr,cov,u} = nlls(&model,sv);

output off;