new;
library ritme,pgraph;

#include nelson.src;

load NS_frf;
Dates_ = NS_frf[.,1]; coefficients = NS_frf[.,2 3 4 5];

R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
tau = 1/12|2/12|3/12|6/12|9/12|1|2|3|4|5|6|7|8|9|10|15|20|25|30;

TauxZero = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = R0~TauxZero~Rinf;

outwidth 256;

output file = pca2.out reset;

{x,va,ve,results} = pca(TauxZero,5);

print "                  ---------------------------------";
print "Vecteurs propres";
print ve;

output off;

sat = vread(results,"sat");

c1 = sat[.,1];
c2 = sat[.,2];
t = seqa(0,2*pi/100,101);

k = cols(TauxZero);

graphset;   
  _pnum = 2; _pdate = ""; _pcross = 1; _pframe = 0; _pnum = 2;
  fonts("simplex simgrma");
  title(" ");
  _pmsgstr = "0\0001/12\0002/12\0003/12\0006/12\0009/12\0001"\
             "\0002\0003\0004\0005\0006\0007"\
             "\0008\0009\00010\00015\00020\00025\00030\000\202\56\201";
  _pmsgctl = 0.00+c1~c2~ones(k,5).*(0.17~0~1~7~0.1); 
  _psym = c1~c2~ones(k,5).*(8~3~2~1~1); 
  xtics(0.75,1,0.05,0);
  ytics(-0.7,0.3,0.2,0);
  xlabel("\2141[er] axe factoriel        ");
  ylabel("\2142[eme] axe factoriel                    ");
  graphprt("-c=1 -cf=pca2.ps");
  xy(cos(t),sin(t)); 
