new;
library ritme,cml;
cmlset;

rndseed 123;

Nobs = 1000;
k = 5;
sigma = 1;

coeff = rndu(k,1);
x = 50*rndu(Nobs,k);
y = x*coeff + rndn(Nobs,1)*sigma;

/*
   beta[1] + ... + beta[k] = 0
   beta[1] + 2 * beta[2] > 5
*/

A = ones(1,k); B = 0;
C = 1~2~zeros(1,k-2);
D = 5;
bnds = { . } ;
{beta,bols} = qpOLS(y,x,A,B,C,D,bnds);

u = y - x*beta;
rss = u'u;
df = rows(u) - cols(x);
sigma = sqrt(rss/df);
cov = (sigma^2)*invpd(x'x);
stderr = sqrt(diag(cov));
tstudent = beta./stderr;
pvalue = 2*cdftc(abs(tstudent),df);

proc mlProc(theta,data);
  local k,y,x,b,sigma2,L,u;

  k = cols(data) - 1;
  y = data[.,1];
  x = data[.,2:1+k];
  b = theta[1:k];
  sigma2 = theta[1+k]^2;

  u = y - x*b;
  L = -0.5*ln(2*pi) - 0.5*ln(sigma2) - 0.5*(u.*u)/sigma2;

  retp(L);
endp;

sv = beta | sigma;

_cml_A = ones(1,k)~0; 
_cml_B = 0;
_cml_C = 1~2~zeros(1,k-2)~0;
_cml_D = 5;

__output = 1;
{theta,Logl,g,cov2,retcode} = cmlprt(cml(y~x,0,&mlProc,sv));

print;
call printfm(beta~stderr~tstudent~pvalue,1,"%lf"~8~3);