new;

cls;

declare matrix r, Mu, Sigma;

proc pdfn3(x,y,z);
  local n,pdf,t,invSigma,i;

  n = rows(z);
  pdf = zeros(n,1);

  invSigma = invpd(Sigma);

  i = 1;
  do until i > n;
    t = x[i]|y[i]|z[i];
    pdf[i] = (t-Mu)'*invSigma*(t-Mu);
    i = i + 1;
  endo;

  retp( exp( -0.5*pdf) / (2*pi)^(3/2) / sqrt(detl) );
endp;

fn rndu2(r,c,a,b) = a + (b-a) .* rndu(r,c);

proc MonteCarlo(ns);
  local I,iter,x,y,z,in,cube;

  ns = ns | 1;
  I = 0;
  iter = ns;
  do until iter > ns[2];
    x = rndu2(ns[1],1,-r,r);
    y = rndu2(ns[1],1,-r,r);
    z = rndu2(ns[1],1,-r,r);
    in = selif(x~y~z, (x^2 + y^2 + z^2) .<= (r^2) );
    if in == error(0);
      iter = iter + 1;
      continue;
    endif;
    I = I + sumc(pdfn3(in[.,1],in[.,2],in[.,3]));
    iter = iter + 1;
  endo;

  cube = 8 * r^3;
  I = cube * I /(ns[1]*ns[2]);

  retp(I);
endp;


rayon = seqa(0.5,0.5,10);
Pr = zeros(10,2);

let ns = 5000 100;

Mu = zeros(3,1);
Sigma = eye(3);

i = 1;
do until i > 10;
  r = rayon[i];
  Pr[i,1] = MonteCarlo(ns);
  print /flush i;
  i = i + 1;
endo;

let Mu = 1 -1 2;
let Sigma[3,3] = 1.0  0.5  0.25
                 0.5  1.0  0.15
                 0.25 0.15 1.0;

i = 1;
do until i > 10; 
  r = rayon[i];
  Pr[i,2] = MonteCarlo(ns);
  print /flush i;
  i = i + 1;
endo;


output file = sphere2.out reset;

print "=============================================================";
print "           rayon               Probabilit      ";
print "                           Sigma1           Sigma2     ";
print "=============================================================";

call printfmt(rayon~Pr,1);

output off;