 /*
  *********************************************************************
  *                                                                   *
  *     Simulated ML estimation of multivariate demand system         *
  *                                                                   *
  *********************************************************************
  */
new;
library maxlik;
#include maxlik.ext;
maxset;
dataset = "indon2";
/* loadm vars[1150,26]= d:\smoking\order.dat; */
 neqt=7;
 nvc=(neqt-1)*((neqt-2))/2 +neqt-1;
 /* nobs=1150; */
 nobs=1150;
let num=1 2 3 4 5 6 7;
neqtd=6; neqtc=6;
nindepv=4;
i=0; z=0;
nparam=nindepv+1;
/*
sh    =vars[1:nobs,1:neqt];
shm   =vars[1:nobs,neqt];
pr    =vars[1:nobs,(neqt +  1):(neqt + neqt )];
prm   =vars[1:nobs,(neqt + neqt)];
id    =vars[1:nobs,(neqt + neqt+1):(neqt+ neqt + neqt)];
nzero =vars[1:nobs,neqt+neqt+neqt+1];
indepv=vars[1:nobs,(neqt+ neqt +neqt +1+1):(neqt+ neqt +neqt +1+nindepv)];
*/
output file = tobit.out reset;

vars={
sh       ,
pr       ,
id       ,
nzero    ,
indepv
    };

 /*
      number of replications
                                */
 nsimul=100;
 epspos=1.e-20;
nvar=rows(vars);
b0=zeros(nindepv*neqt,1);
/* Starting values for Rho's */
/*
rho011
rho012 rho022
rho013 rho023 rho033
rho014 rho024 rho034 rho044
rho015 rho025 rho035 rho045 rho055
rho016 rho026 rho036 rho046 rho056 rho066
 */

 rho0=zeros(nvc,1);
   sigvecf=rho0;
/*
     obtain a seed for each indiv
                                      */
seedvec=zeros(nobs,1);
seed0=-1234567;
seed=seed0; if seed > 0; seed=-seed; endif;
i=1;
do until i>nobs;
   seed=floor(1.e+7*ran1g(seed));
   seedvec[i,1]=seed;
i=i+1;
endo;
nvar=rows(vars);

minsh={0,0,0,0,0,0.0,0.032284895};
/*  beta0={
    -.0508,    -.0383,    -.1334,    -.0245,    -.0041,    -.0012,
     .00556 }; */
/* beta0={-0.018, -0.043, -0.245,-0.070, -0.027, -0.024, -0.184}; */
beta0={ -.0311,    -.0252,    -.1549,    -.0522,    -.0090,    -.0049, .0238 };
beta0=ln(minsh-beta0);
/* delta0={
   -1.4826 ,  -.0139 ,   -.1513 ,   -.0598  ,
   -2.1353 ,   .0251 ,   -.0684 ,    .0758  ,
    -.6732 ,  -.0343 ,   -.0670 ,    .0196  ,
    -.7094 ,  -.0400 ,   -.0385 ,    .0118  ,
    -.9160 ,  -.0031 ,   -.0295 ,   -.0133  ,
    -.7833 ,  -.0052 ,   -.0307 ,    .0009  }; */
/*
delta0=
    { -1.987,   0.008,  -0.010,  -0.042,
     -1.239,  -0.089,  -0.055,  -0.089,
     -0.127,  -0.042,  -0.059,  -0.080,
     -0.747,  -0.075,  -0.043,  -0.053,
     -1.033,  -0.032,  -0.045,  -0.037,
     -0.879,   0.002,  -0.026,  -0.006};
*/
delta0={
   -1.7758,   -.0410,    -.0518,    -.1284,
   -1.8903,   -.0242,    -.0616,    -.1043,
    -.7405,   -.0329,    -.0657,    -.1129,
    -.6520,   -.0387,    -.0446,    -.0332,
    -.7597,   -.0097,    -.0417,    -.0348,
    -.6509,   -.0132,    -.0258,    -.0245 };
/*
sigvecf0={
    3.7301,
    4.7746,   7.7904,
    1.5647,   2.2985,    1.3428,
     .3128,    .4272,     .2367,     .6667,
    1.1153,   1.6854,     .5020,     .0853,     .8150,
     .9981,   1.4644,     .5199,     .0482,     .4082,    1.0599}; */
/*
sigvecf0={
     4.640,
     2.244,2.152,
     1.101,0.815,0.715,
     0.931,0.640,0.326,0.577,
     0.835,0.560,0.295,0.182,0.360,
     0.526,0.381,0.191,0.149,0.112,0.196};
  */

sigvecf0={
    5.0227,
    4.4746,   5.3205,
    3.2481,   3.3835,    2.7483,
    1.1592,   1.1626,     .8253,     .8960,
     .9786,   1.0676,     .6779,     .3773,     .8299,
    1.1735,   1.2987,     .8925,     .4813,     .4948,     .6788 };
sigvecf0=vech(chol(xpnd(sigvecf0))');
b00=beta0|delta0|sigvecf0;
/* {fval}= ssmllf(b00,vars);
sumc(fval);
*/

output on;
/*
      Derivative Check: Analytical against Numerical

                                                             */
/*
/* _max_GradProc=&ssmlfd; */
_max_NumObs=nobs;
/* _max_GradCheckTol=0.001;  */
_max_MaxIters=1;
_max_CovPar=2;
      call maxprt(maxlik("indon2",0,&ssmllf,b00));
*/
output off;
/*  call maxprt(beta0,fval,g,cov,retcode); */
/*
           starting value by Independent Probits
                                                       */

output on;
/* _max_GradProc=&ssmlfd; */
_mlCovP=2;
_mglTol=0.05;
{b,fval,g,cov,retcode}=maxlik("indon2",0,&ssmllf,b00);
   call maxprt(b,fval,g,cov,retcode);

output off;
/* ******************************************************
 *
 *                  Procedures
 *
 ******************************************************** */

proc ssmllf(parvec,vars);
/* -------------------------------------------


             likelihood function:
              Multivarite Probit

   -------------------------------------------- */
local
      xb,wmat,cholw,
      i,istri,iendi,tii,ym11i,ai,bi,xbi,wmati,invwmati,cholwi,seedi,umati,
      parm,fval,seed,seed0, omega, pvec,
      ym11, hc, hu , iwmati,bii, xbii,weight,
      mu,depv,indepv,sigvecf,
      delta1, delta2, delta3, delta4, delta5, delta6, delta7,
      like0, like1, gg, ggi, sigma, sigmai,
      sigma11, sigma12, sigma21, sigma22, sh, pr, id,nzero,
      ee, ee1,ee0,rr,cholw1,idi,nzeroi,shm,prm,
      bb,bbm,shi,pri,bbi,bbmi,dbb,dbbm,shmi,prmi,jacobt,ggi1,ggi0,
      minsh,idi1,idi0,zeronei,zero1i
      ;
 /*
       dependent and independant variables
                                                 */
sh    =vars[1:nobs,1:neqt];
shm   =vars[1:nobs,neqt];
pr    =vars[1:nobs,(neqt +  1):(neqt + neqt )];
prm   =vars[1:nobs,(neqt + neqt)];
id    =vars[1:nobs,(neqt + neqt+1):(neqt+ neqt + neqt)];
nzero =vars[1:nobs,neqt+neqt+neqt+1];
indepv=vars[1:nobs,(neqt+ neqt +neqt +1+1):(neqt+ neqt +neqt +1+nindepv)];
/*
    parameter vector: first one is beta
                                                 */
dbb    =parvec[1:neqt];
dbbm   =parvec[neqt];
delta1=parvec[neqt+1:neqt+(nindepv).*1];
delta2=parvec[neqt+(nindepv).*1+1:neqt+(nindepv).*2];
delta3=parvec[neqt+(nindepv).*2+1:neqt+(nindepv).*3];
delta4=parvec[neqt+(nindepv).*3+1:neqt+(nindepv).*4];
delta5=parvec[neqt+(nindepv).*4+1:neqt+(nindepv).*5];
delta6=parvec[neqt+(nindepv).*5+1:neqt+(nindepv).*6];
sigvecf=parvec[neqt+(nindepv.*(neqt-1))+1:neqt+(nindepv.*(neqt-1))+nvc];
gg=   (indepv*delta1)~
      (indepv*delta2)~
      (indepv*delta3)~
      (indepv*delta4)~
      (indepv*delta5)~
      (indepv*delta6) ;
/* transform beta from deep parameters */
minsh =minc(sh./pr);
bb=minsh-exp(dbb);
bbm=minsh[neqt]-exp(dbbm);

/*
     set up the variance-covariance matrix
     vector --> (upper) cho-matrix --> var-cov
                                              */
/*  sigma=xpnd(sigvecf); */
sigma=upmat(xpnd(sigvecf));
sigma=sigma'sigma;
fval=zeros(nobs,1);

/*
    compute each observation's contribution to the llf
                                                         */
i=1;
do until i > nobs;
/* get rid of the last good */
/*     idi=packr(miss(id[i,.]',neqt)); */
      idi=id[i,1:neqt-1];
/*    iidi=indnv(num,id[i,.]'); */
/* re-arrange the data, var-cov first */
      sigmai=submat(sigma,idi,idi);
      seedi=seedvec[i,1];
      pri=pr[i,1:neqt-1]';
      shi=sh[i,1:neqt-1]';
      ggi=gg[i,1:neqt-1]';
      bbi=bb[1:neqt-1];
      prmi=pr[i,neqt];
      shmi=sh[i,neqt];
      bbm=bb[neqt];
      nzeroi=nzero[i];
      nzeroi=(nzeroi-(shmi .== 0));
      zeronei=(2*(shi.>0)-1); /* create a 1/-1 variable */
      zero1i=(zeronei+1)./2; /* create a 1/0 variable */
      if nzeroi >0;       idi0=idi[1:nzeroi];        endif;
      if nzeroi < neqt-1; idi1=idi[nzeroi+1:neqt-1]; endif;
/* nzeroi=nzero[i]-(shmi .== 0); */
if nzeroi>0;      ggi0=ggi[idi0];        endif;
if nzeroi<neqt-1; ggi1=ggi[idi1];        endif;
/*
         Partitioning and sorting of Var-Cov Matrix
                                          */
if (nzeroi >0) and (nzeroi < neqt-1);
sigma11=submat(sigma,idi0,idi0);
sigma12=submat(sigma,idi0,idi1);
sigma21=submat(sigma,idi1,idi0);
sigma22=submat(sigma,idi1,idi1);
elseif (nzeroi == neqt-1);
sigma11=sigma;
elseif (nzeroi == 0);
sigma22=sigma;
endif;
/*
  ee=ln(s_i-v_i*b_i) - ln(s_m-v_m*b_m) ) -gamma_i,  (i= 1, ..., neqt-1)
                                                             */
      like1=0;
      like0=0;
      ee=    ln(shi-pri.*bbi)
           - (ln(shmi - prmi.*bbm)).*ones(neqt-1,1) -ggi;
      /* sorting is done at this stage                */
      /*
             take care of the NON-ZERO part
       .............................................  */
      if (nzeroi < neqt-1);
      ee1=ee[idi1];
      if (shmi==0);
        jacobt=(sumc( (shi - pri.*bbi).*zero1i))
             /(prodc(  ( (shi - pri.*bbi).*zero1i )+
             (ones(neqtc,1)-zero1i)    ) );
      else;
        jacobt=(sumc( (shi - pri.*bbi).*zero1i) + (shmi-prmi*bbm) )
             /(prodc(  ((shi - pri.*bbi).*zero1i)+
             (ones(neqtc,1)-zero1i)    )*(shmi-prmi*bbm) );
      endif;
      like1= - 0.5*ln(2*pi)*(neqt-1-nzeroi)
             - 0.5*ln(det(sigma22))
             - 0.5*(ee1'inv(sigma22)*ee1);
      like1=like1+ln(abs(jacobt));
      endif;
       /*
                 take care of the ZEROS
         .............................................  */

      if (nzeroi > 0);
       ee0=ee[idi0];
      rr=ee0-sigma12*inv(sigma22)*(ee1 );
      /* rr'; */
      wmati=(sigma11-sigma12*inv(sigma22)*sigma21);
      cholwi=chol(wmati)';
      iwmati=inv(wmati);
      umati=rndus(neqt-1,nsimul,seedi);
      /* umati=umati[idi,.]; */
      umati=umati[1:nzeroi,.];
      bii=(-1.0e10).*ones(nzeroi,1);
      mu=0*ones(nzeroi,1);
      {pvec,hu,hc}=GHK0(nzeroi,mu,wmati,iwmati,cholwi,bii,rr,nsimul,Umati,0);
      like0=ln(pvec+epspos);
      endif;
fval[i]=like0+like1;
i=i+1;
endo;
retp((fval));
endp;

proc ssmlfd(parvec,vars);
/* -------------------------------------------


             likelihood function:
              Multivarite Probit

   -------------------------------------------- */
local
      xb,wmat,cholw,
      i,istri,iendi,tii,ym11i,ai,bi,xbi,wmati,invwmati,cholwi,seedi,umati,
      parm,fval,seed,seed0, omega, pvec,
      ym11, hc, hu , iwmati,bii, xbii,weight,
      mu,depv,indepv,sigvecf,
      delta1, delta2, delta3, delta4, delta5, delta6, delta7,
      like0, like1, gg, ggi, sigma, sigmai,
      sigma11, sigma12, sigma21, sigma22, sh, pr, id,nzero,
      ee, ee1,ee0,rr,cholw1,idi,nzeroi,shm,prm,
      bb,bbm,shi,pri,bbi,bbmi,dbb,dbbm,shmi,prmi,jacobt,ggi2,
      bbi0,bbi1,pri0,pri1,idi0,idi1,ggi1,ggi0,shi1,shi0,
      minsh,dbeta,ddelta,dbetam1,dbetam0,dbetam,dsmat122,dsmat022,
      dsmat22,dsmat12,dsmat21,dsmat11,dsmat,fstdrv


      ;
 /*
       dependent and independant variables
                                                 */
sh    =vars[1:nobs,1:neqt];
shm   =vars[1:nobs,neqt];
pr    =vars[1:nobs,(neqt +  1):(neqt + neqt )];
prm   =vars[1:nobs,(neqt + neqt)];
id    =vars[1:nobs,(neqt + neqt+1):(neqt+ neqt + neqt)];
nzero =vars[1:nobs,neqt+neqt+neqt+1];
indepv=vars[1:nobs,(neqt+ neqt +neqt +1+1):(neqt+ neqt +neqt +1+nindepv)];

/*
    parameter vector: first one is beta
                                                 */
dbb    =parvec[1:neqt];
dbbm   =parvec[neqt];
delta1=parvec[neqt+1:neqt+(nindepv).*1];
delta2=parvec[neqt+(nindepv).*1+1:neqt+(nindepv).*2];
delta3=parvec[neqt+(nindepv).*2+1:neqt+(nindepv).*3];
delta4=parvec[neqt+(nindepv).*3+1:neqt+(nindepv).*4];
delta5=parvec[neqt+(nindepv).*4+1:neqt+(nindepv).*5];
delta6=parvec[neqt+(nindepv).*5+1:neqt+(nindepv).*6];
sigvecf=parvec[neqt+(nindepv.*(neqt-1))+1:neqt+(nindepv.*(neqt-1))+nvc];
gg=   (indepv*delta1)~
      (indepv*delta2)~
      (indepv*delta3)~
      (indepv*delta4)~
      (indepv*delta5)~
      (indepv*delta6) ;
/* transform beta from deep parameters */
minsh =minc(sh);
bb=minsh-exp(dbb);
bbm=minsh[neqt]-exp(dbbm);

/*
     set up the variance-covariance matrix
     vector --> cho-matrix --> var-cov
                                              */
sigma=upmat(xpnd(sigvecf));
sigma=sigma'sigma;
fval=zeros(nobs,1);

/*
    compute each observation's contribution to the llf
                                                         */
i=1;
do until i > nobs;
/* get rid of the last good */
      idi=packr(miss(id[i,.]',neqt));
/* re-arrange the data, var-cov first */
      sigmai=submat(sigma,idi,idi);
      seedi=seedvec[i,1];
      pri=pr[i,idi]';
      shi=sh[i,idi]';
      ggi=gg[i,idi]';
      bbi=bb[idi];
      prmi=prm[i];
      shmi=shm[i];


nzeroi=nzero[i]-(shmi .== 0);
if nzeroi>0;
            ggi0=ggi[1:nzeroi];
            pri0=pri[1:nzeroi];
            shi0=shi[1:nzeroi];
            bbi0=bbi[1:nzeroi];
            idi0=idi[1:nzeroi];
endif;
if nzeroi<neqt-1;
            ggi1=ggi[nzeroi+1:neqt-1];
            pri1=pri[nzeroi+1:neqt-1];
            shi1=shi[nzeroi+1:neqt-1];
            bbi1=bbi[nzeroi+1:neqt-1];
            idi1=idi[nzeroi+1:neqt-1];
endif;
/*
         Partitioning of Var-Cov Matrix
                                          */
if (nzeroi >0) and (nzeroi < neqt-1);
sigma11=sigmai[1:nzeroi       ,1:nzeroi       ];
sigma12=sigmai[1:nzeroi       ,nzeroi+1:neqt-1];
sigma21=sigmai[nzeroi+1:neqt-1,1:nzeroi       ];
sigma22=sigmai[nzeroi+1:neqt-1,nzeroi+1:neqt-1];
elseif (nzeroi == neqt-1);
sigma11=sigmai;
elseif (nzeroi == 0);
sigma22=sigmai;
endif;
/*
  ee=ln(s_i-v_i*b_i) - ln(s_m-v_m*b_m) ) -gamma_i,  (i= 1, ..., neqt-1)
                                                             */
      like1=0;
      like0=0;
      jacobt=1;
      dbeta=zeros(neqt-1,1);
      dbetam1=0;
      dbetam0=0;
      ddelta=zeros(neqt-1,nindepv);
      fstdrv=zeros(rows(parvec),nobs);

      ee=    ln(shi-pri.*bbi)
           - (ln(shmi - prmi.*bbm)).*ones(neqt-1,1) -ggi;
      /*
             take care of the NON-ZERO part
       .............................................  */
      if (nzeroi < neqt-1);
      ee1=ee[nzeroi+1:neqt-1];
        jacobt=(sumc( shi[nzeroi+1:neqt-1]
                  - pri[nzeroi+1:neqt-1].*bbi[nzeroi+1:neqt-1]))
             /(prodc( shi[nzeroi+1:neqt-1]
                  - pri[nzeroi+1:neqt-1].*bbi[nzeroi+1:neqt-1]));
      like1= - 0.5*ln(2*pi)*(neqt-1-nzeroi)
             - 0.5*ln(det(sigma22))
             - 0.5*(ee1'inv(sigma22)*ee1);
      like1=like1+ln(abs(jacobt));
      dbeta[idi1]=ee1.*(-pri1./(pri1.*bbi1));
      dbeta[idi1]= dbeta[idi1]
                    .*((-1./((shi1-pri1).*.jacobt) -
                      ( -1./(prodc( shi[nzeroi+1:neqt-1]
                        - pri[nzeroi+1:neqt-1].*bbi[nzeroi+1:neqt-1]))
                       ).*ones(neqt-1,1)
                       )).*.(abs(1/jacobt)) ;
      dbeta[idi1]=inv(sigma22)*dbeta[idi1];
      ddelta[idi1,.]=(inv(sigma22)*ee1).*.indepv[i,.];
      dbetam1=(sumc(inv(sigma22)*ee1) )
                    ./(-prmi./(shmi-prmi.*bbm)) ;
      dsmat122=(-0.5).*.(inv(sigma22))*(sigma22-ee1*ee1')*(inv(sigma22));
      endif;
       /*
                 take care of the ZEROS
         .............................................  */

      if (nzeroi > 0);
       ee0=ee[1:nzeroi];
      rr=ee0-sigma12*inv(sigma22)*(ee1 );
      cholwi=chol(sigma11-sigma12*inv(sigma22)*sigma21)';
      wmati=(sigma11-sigma12*inv(sigma22)*sigma21);
      iwmati=inv(sigma11-sigma12*inv(sigma22)*sigma21);
      umati=rndus(neqt-1,nsimul,seedi);
      umati=umati[idi,.];
      umati=umati[1:nzeroi,.];
      bii=(-1.0e10).*ones(nzeroi,1);
      mu=0*ones(nzeroi,1);
      {pvec,hu,hc}=GHK(neqt,mu,wmati,iwmati,cholwi,bii,xbi,nsimul,Umati,0);      {pvec,hu,hc}=GHK0(nzeroi,mu,wmati,iwmati,cholwi,bii,rr,nsimul,Umati,0);
      /* they are row vectors now */
      dbeta[idi0]=hc[2:nzeroi+1,1].*(pri0./(pri0.*bbi0))';
      dbetam0=(sumc(hc[2:nzeroi+1,1]).*(-prmi./(shmi-prmi.*bbm)));
      ddelta[idi0,.]=(hc[2:nzeroi+1,1].*.indepv[i,.]);
      dsmat11=hc[2:nzeroi+1,2:nzeroi+1];
      dsmat022=hc[2:nzeroi+1,2:nzeroi+1]
               .*(inv(sigma22)*(sigma21*sigma12)*inv(sigma22))
               + hc[1,2:nzeroi+1]'
                 .*(inv(sigma22)*(sigma21*sigma12)*inv(sigma22));
      dsmat12=  hc[2:nzeroi+1,2:nzeroi+1].*(inv(sigma22)*sigma21).*2
              + hc[1,2:nzeroi+1]'.*(inv(sigma22)*sigma21).*2;
      dsmat21=dsmat21';
      dsmat=(dsmat11~dsmat12)|
            (dsmat21~(dsmat122+dsmat022));
      endif;

      if (nzeroi==0);
      dsmat=dsmat122;
      endif;

      ddelta=vecr(ddelta);
      /* re-arrange the var-cov matrix in accordance to the original order */
      dsmat=submat(dsmat,idi,idi);
      dsmat=dsmat*(chol(sigma)');
      dbeta=dbeta.*exp(dbb[1:neqt-1]).*dbb[1:neqt-1];
      dbetam=(dbetam1+dbetam0)*exp(dbbm).*dbbm;

          fstdrv[1:rows(parvec),i]=(   dbeta|dbetam|ddelta|(vech(dsmat))
                      );
i=i+1;
endo;
retp((fstdrv'));
endp;

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  M. Geweke-Hajivassiliou-Keane Simulator (GHK)

--- GHKP version returns ONLY P ---

     The GHK procedure assumes that U is an array of uniform [0,1] variates,
independent within columns, and in general independent between columns.
It does not use PARM.  It returns both HU and HC. 

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

PROC 1 = GHKP(M,MU,W,WI,C,A,B,R,U,PARM);
LOCAL J,II,TA,TB,TT,WGT,V,HU,P,HC;
@vah: guard against possible division by 0, by adding 1.e-100 to denominators@
J = 1;
II = 1;
TA = CDFN((A[1,1]-MU[1,1])/(C[1,1]+1.e-100))*ONES(1,R); @1ST COMPONENT BOUNDS@
TB = CDFN((B[1,1]-MU[1,1])/(C[1,1]+1.e-100))*ONES(1,R);
/*TT = CDFNI(U[1,.].*TA+(1-U[1,.]).*TB);*/
TT = CDFINVN(U[1,.].*TA+(1-U[1,.]).*TB);
WGT = TB-TA;
DO WHILE J < M;                                         @LOOP OVER COMPONENTS@
  J = J+1;
  @COMPONENT J BOUNDS@
  TA = CDFN(((A[J,1]-MU[J,1])*ONES(1,R)-C[J,II]*TT)/(C[J,J]+1.e-100));
  TB = CDFN(((B[J,1]-MU[J,1])*ONES(1,R)-C[J,II]*TT)/(C[J,J]+1.e-100));
/*  TT = TT|CDFNI(U[J,.].*TA+(1-U[J,.]).*TB);           @COMPONENT J DRAW@*/
  TT = TT|CDFINVN(U[J,.].*TA+(1-U[J,.]).*TB);           @COMPONENT J DRAW@
  II = II|J;
  WGT = WGT.*(TB-TA);                                   @ ACCUMULATE WEIGHT@
ENDO;
V = C*TT;                                               @TRANSFORM TO V-MU@
TT = (ONES(M,1)*WGT).*V;
P = SUMC(WGT')/R;

RETP(P);
ENDP;


declare matrix ran1arr != -999;

proc ran1g(idum);
/*
** RAN1G.G
**
** ran1=ran1g(idum);
**
**  vah 1:15 pm, Friday, May 8, 1987
** from Numerical Recipes, pp.196-7
**
** Dimension of shuffling array changed to LEN=96
** Global array RAN1ARR version, dimensioned(LEN+4,1)
*/

@local idum,r,len;@
local r,len;
local m1,ia1,ic1,rm1,ix1,m2,ia2,ic2,rm2,ix2,m3,ia3,ic3,rm3,ix3,j,ran1,ran1sav;

len=96;
r=zeros(len,1);
if idum>=0;
/*loadm ran1sav;*/
ran1sav=varget("ran1arr");
r[1:len,1]=ran1sav[1:len,1];
ix1=ran1sav[len+1,1]; ix2=ran1sav[len+2,1]; ix3=ran1sav[len+3,1];
idum=ran1sav[len+4,1];
else;
ix1=0;
ix2=0;
ix3=0;
endif;
@"r";r';@
m1=259200; ia1=7141; ic1=54773; rm1=1/m1;
m2=134456; ia2=8121; ic2=28411; rm2=1/m2;
m3=243000; ia3=4561; ic3=51349;
if idum<0;
@"idum<0...";     @
ix1=(ic1-idum)%m1;
ix1=(ia1*ix1+ic1)%m1;
ix2=ix1%m2;
ix1=(ia1*ix1+ic1)%m1;
ix3=ix1%m3;
j=1;
do until j>len;
ix1=(ia1*ix1+ic1)%m1;
ix2=(ia2*ix2+ic2)%m2;
r[j,1]=(ix1+ix2*rm2)*rm1;
j=j+1;
endo;
idum=1;
endif;
@"after if... ix3 " ix3; @
ix1=(ia1*ix1+ic1)%m1;
ix2=(ia2*ix2+ic2)%m2;
ix3=(ia3*ix3+ic3)%m3;
j=1+trunc(len*ix3/m3);
if j>len or j<1; "error in ran1... j=" j; end; endif;
@"j" j;@
ran1=r[j,1];
r[j,1]=(ix1+ix2*rm2)*rm1;
ran1sav=r|ix1|ix2|ix3|idum;
/*save ran1sav;*/
j=varput(ran1sav,"ran1arr");
@"ran1sav";ran1sav'; "ran1" ran1;@
retp(ran1);
endp;


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  M. Geweke-Hajivassiliou-Keane Simulator (GHK)

--- GHKNP version returns ONLY P and assumes a NEGATIVE ORTHANT PROB ---
 14:25:06.23, Wed, Sep 14, 1994

     The GHK procedure assumes that U is an array of uniform [0,1] variates,
independent within columns, and in general independent between columns.
It does not use PARM.  It returns both HU and HC. 

-- NOTE: will differ slightly from GHKP because (1-u)*ta+u*tb used
--       instead of u*ta+(1-u)*tb

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

proc 1 = ghknp(m,mu,w,wi,c,a,b,r,u,parm);
local e,tb,wgt,j,jm1,p;
@vah: guard against possible division by 0, by adding 1.e-100 to denominators@
e=zeros(m,r);
tb=cdfn(-mu[1,1]/(c[1,1]+1.e-100));
e[1,.]=cdfinvn(u[1,.].*tb);
wgt=tb;
j=2;
jm1=1;
do until j>m;
      tb=cdfn((-mu[j,1]-c[j,jm1]*e[jm1,.])/(c[j,j]+1.e-100));
      e[j,.]=cdfinvn(u[j,.].*tb);
      wgt=wgt.*tb;
      jm1=jm1|j;
j=j+1;
endo;
p = sumc(wgt')/r;
retp(p);
endp;



/*
** CDFINVN --   computes the inverse normal cdf. The algorithm used is taken
**              from Kennedy and Gentle, STATISTICAL COMPUTING, p. 95.
**
** vah 22:57:35.78, Sun, Jul 23, 1989
** Taken intact from V149b MAXPROC3.ARC
**
**              xp=cdfinvn(p);
**
**             INPUT
**              p -- nx1 vector of probabilities (that is, 0 < p < 1)
**             OUTPUT
**             xp -- the corresponding vector of values such that: cdfn(xp)=p;
**
**              This algorithm seems to be very accurate.  It is
**              rated to be accurate to 1e-7.  However, it appears
**              to be substantially more accurate -- approximately
**              1e-10.
**
*/

proc 1=cdfinvn(p);
local lim, p0, p1, p2, p3, p4, q0, q1, q2, q3, q4, maskgt, maskeq, sgn,
y, xp, pn;

@ Constants @

lim =  1e-20;

p0  = - 0.322232431088;             q0  =   0.0993484626060;
p1  = - 1.0;                        q1  =   0.588581570495;
p2  = - 0.342242088547;             q2  =   0.531103462366;
p3  = - 0.0204231210245;            q3  =   0.103537752850;
p4  = - 0.453642210148*1e-4;        q4  =   0.38560700634*1e-2;


@ Main body of code @

 @ Create masks for handling p > .5 and p >= .5 @

maskgt=(p .> 0.5);
maskeq=(p .ne 0.5);
sgn=missrv(miss(maskgt,0),-1);

 @ Convert p > .5 --> 1-p @

pn=(maskgt-p).*sgn;   clear maskgt;

 @ Computation of function for p < 0.5 @

y=sqrt(-2*ln(pn));     clear pn;
xp=y + ((((y*p4 + p3).*y + p2).*y + p1).*y + p0)./
       ((((y*q4 + q3).*y + q2).*y + q1).*y + q0); clear y;

 @ Convert results for p > .5 and p = .5 @

xp=(xp.*sgn).*maskeq;
clear sgn, maskeq;
retp(xp);
endp;



/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  M. Geweke-Hajivassiliou-Keane Simulator (GHK)
     The GHK procedure assumes that U is an array of uniform [0,1] variates,
independent within columns, and in general independent between columns.
It does not use PARM.  It returns both HU and HC. 

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

PROC 3 = GHK0(M,MU,W,WI,C,A,B,R,U,PARM);
LOCAL J,II,TA,TB,TT,WGT,V,HU,P,HC;
@vah: guard against possible division by 0, by adding 1.e-100 to denominators@
J = 1;
II = 1;
TA = CDFN((A[1,1]-MU[1,1])/(C[1,1]+1.e-100))*ONES(1,R); @1ST COMPONENT BOUNDS@
TB = CDFN((B[1,1]-MU[1,1])/(C[1,1]+1.e-100))*ONES(1,R);
/*TT = CDFNI(U[1,.].*TA+(1-U[1,.]).*TB);*/
TT = CDFINVN(U[1,.].*TA+(1-U[1,.]).*TB);
WGT = TB-TA;
DO WHILE J < M;                                         @LOOP OVER COMPONENTS@
  J = J+1;
  @COMPONENT J BOUNDS@
  TA = CDFN(((A[J,1]-MU[J,1])*ONES(1,R)-C[J,II]*TT)/(C[J,J]+1.e-100));
  TB = CDFN(((B[J,1]-MU[J,1])*ONES(1,R)-C[J,II]*TT)/(C[J,J]+1.e-100));
/*  TT = TT|CDFNI(U[J,.].*TA+(1-U[J,.]).*TB);           @COMPONENT J DRAW@*/
  TT = TT|CDFINVN(U[J,.].*TA+(1-U[J,.]).*TB);           @COMPONENT J DRAW@
  II = II|J;
  WGT = WGT.*(TB-TA);                                   @ ACCUMULATE WEIGHT@
ENDO;
P = SUMC(WGT')/R;
RETP(P,0,0);
ENDP;

PROC 3 = GHK(M,MU,W,WI,C,A,B,R,U,PARM);
LOCAL J,II,TA,TB,TT,WGT,V,HU,P,HC;
@vah: guard against possible division by 0, by adding 1.e-100 to denominators@
J = 1;
II = 1;
TA = CDFN((A[1,1]-MU[1,1])/(C[1,1]+1.e-100))*ONES(1,R); @1ST COMPONENT BOUNDS@
TB = CDFN((B[1,1]-MU[1,1])/(C[1,1]+1.e-100))*ONES(1,R);
/*TT = CDFNI(U[1,.].*TA+(1-U[1,.]).*TB);*/
TT = CDFINVN(U[1,.].*TA+(1-U[1,.]).*TB);
WGT = TB-TA;
DO WHILE J < M;                                         @LOOP OVER COMPONENTS@
  J = J+1;
  @COMPONENT J BOUNDS@
  TA = CDFN(((A[J,1]-MU[J,1])*ONES(1,R)-C[J,II]*TT)/(C[J,J]+1.e-100));
  TB = CDFN(((B[J,1]-MU[J,1])*ONES(1,R)-C[J,II]*TT)/(C[J,J]+1.e-100));
/*  TT = TT|CDFNI(U[J,.].*TA+(1-U[J,.]).*TB);           @COMPONENT J DRAW@*/
  TT = TT|CDFINVN(U[J,.].*TA+(1-U[J,.]).*TB);           @COMPONENT J DRAW@
  II = II|J;
  WGT = WGT.*(TB-TA);                                   @ ACCUMULATE WEIGHT@
ENDO;
V = C*TT;                                               @TRANSFORM TO V-MU@
TT = (ONES(M,1)*WGT).*V;
P = SUMC(WGT')/R;
HU = WI*V*(TT')*WI/R-P*WI;
V = WI*SUMC(TT')/R;
HU = (P|V)~((V')|(HU/2));
IF P > 0;
  HC = HU/P;
  ELSE;
  HC = -999*ONES(M+1,M+1);
ENDIF;
RETP(P,HU,HC);
ENDP;

