/*
**  LUTKEPOHL [1991], Introduction to Multiple Time Series Analysis,
**  Springer-Verlag, Berlin-Heidelberg
**
*/

new;
library ritme;

cls;

load y[92,3] = lutkepoh.asc;
y = ln(y[1:76,.]);

INVEST = y[.,1];
INCOME = y[.,2];
CONSUM = y[.,3];

let names = INVEST INCOME CONSUM;

outwidth 256;
output file = vecm1.out reset;

lag_ = 1;
do until lag_ > 10;
  {lambda,logl,lambda_trace,lambda_max,table} = JohansenTest(y,lag_);
  lag_ = lag_ + 1;
endo;

output off;

lag_ = 4;

{lambda,logl,lambda_trace,lambda_max,table} = JohansenTest(y,lag_);

output file = vecm1.out on;

rank_ = 1;
do until rank_ > 1;
  {alpha,beta,Pi_} = JohansenCoint(table,rank_);
  print "----------------------------------------------";
  print ftos(rank_,"            rank = %lf",3,0);
  print "Pi = ";
  print Pi_;
  print "beta = ";
  print beta./beta[2];
  rank_ = rank_ + 1;
endo;

output off;